std::is_integral(3)

NAME
std::is_integral - std::is_integral

Synopsis
   Defined in header <type_traits>
   template< class T > (since C++11)
   struct is_integral;
   Checks whether T is an integral type. Provides the member constant value which is
   equal to true, if T is the type bool, char
   , char8_t
   (since C++20), char16_t, char32_t, wchar_t, short, int, long, long long, or any
   implementation-defined extended integer types, including any signed, unsigned, and
   cv-qualified variants. Otherwise, value is equal to false.
   The behavior of a program that adds specializations for is_integral
   or is_integral_v
   (since C++17) is undefined.

Template parameters
   T - a type to check
  Helper variable template
   template< class T > (since C++17)
   inline constexpr bool is_integral_v = is_integral<T>::value; Inherited from std::integral_constant

Member constants
   value true if T is an integral type , false otherwise
   [static] (public static member constant)

Member functions
   operator bool converts the object to bool, returns value
                 (public member function)
   operator() returns value
   (C++14) (public member function)

Member types
   Type Definition
   value_type bool
   type std::integral_constant<bool, value>

Example
// Run this code
 #include <iostream>
 #include <iomanip>
 #include <type_traits>
 class A {};
 enum E : int {};
 template <class T>
 T f(T i)
 {
     static_assert(std::is_integral<T>::value, "Integral required.");
     return i;
 }
 #define SHOW(...) std::cout << std::setw(29) << #__VA_ARGS__ << " == " << __VA_ARGS__ << '\n'
 int main()
 {
     std::cout << std::boolalpha;
     SHOW( std::is_integral<A>::value );
     SHOW( std::is_integral_v<E> );
     SHOW( std::is_integral_v<float> );
     SHOW( std::is_integral_v<int> );
     SHOW( std::is_integral_v<const int> );
     SHOW( std::is_integral_v<bool> );
     SHOW( f(123) );
 }

Output:
    std::is_integral<A>::value == false
         std::is_integral_v<E> == false
     std::is_integral_v<float> == false
       std::is_integral_v<int> == true
 std::is_integral_v<const int> == true
      std::is_integral_v<bool> == true
                        f(123) == 123

See also
   integral specifies that a type is an integral type
   (C++20) (concept)
   is_integer identifies integer types
   [static] (public static member constant of std::numeric_limits<T>)
   is_floating_point checks if a type is a floating-point type
   (C++11) (class template)
   is_arithmetic checks if a type is an arithmetic type
   (C++11) (class template)
   is_enum checks if a type is an enumeration type
   (C++11) (class template)